import Control.Concurrent
import Control.Concurrent.MVar
import Control.Monad (forever)

import Lib

pickFork :: MVar String -> String -> IO String
pickFork fork name = do
  forkName <- takeMVar fork
  putStrLn $ "Philosopher " ++ name ++ " pick " ++ forkName
  return forkName

putFork :: MVar String -> String -> String -> IO ()
putFork fork forkName name = do
  putStrLn $ "Philosopher " ++ name ++ " put " ++ forkName
  putMVar fork forkName

createPhilosopher :: String -> MVar String -> MVar String -> IO ()
createPhilosopher name fork1 fork2 = forever $ do
  think name
  fork1Name <- pickFork fork1 name
  fork2Name <- pickFork fork2 name
  eat name
  putFork fork2 fork2Name name
  putFork fork1 fork1Name name

main = do
  fork1 <- newMVar "fork1"
  fork2 <- newMVar "fork2"
  fork3 <- newMVar "fork3"
  fork4 <- newMVar "fork4"
  fork5 <- newMVar "fork5"
  forkIO $ createPhilosopher "P1" fork1 fork5
  forkIO $ createPhilosopher "P2" fork1 fork2
  forkIO $ createPhilosopher "P3" fork2 fork3
  forkIO $ createPhilosopher "P4" fork3 fork4
  forkIO $ createPhilosopher "P5" fork4 fork5
  readLn :: IO String
