import System.Random
import Control.Monad (forever)
import Control.Concurrent.STM
import Control.Concurrent (forkIO)

import Lib

createPhilosopher :: String -> TMVar String -> TMVar String -> IO ()
createPhilosopher name fork1 fork2 = forever $ do
  think name
  (fork1Name, fork2Name) <- atomically $ do
    fork1Name <- takeTMVar fork1
    fork2Name <- takeTMVar fork2
    return (fork1Name, fork2Name)
  putStrLn $ "Philosopher " ++ name ++ " pick " ++ fork1Name ++ " and " ++ fork2Name
  eat name
  atomically $ do
    putTMVar fork1 fork1Name
    putTMVar fork2 fork2Name
  putStrLn $ "Philosopher " ++ name ++ " put " ++ fork1Name ++ " and " ++ fork2Name

main = do
  fork1 <- newTMVarIO "fork1"
  fork2 <- newTMVarIO "fork2"
  fork3 <- newTMVarIO "fork3"
  fork4 <- newTMVarIO "fork4"
  fork5 <- newTMVarIO "fork5"
  forkIO $ createPhilosopher "P1" fork5 fork1
  forkIO $ createPhilosopher "P2" fork1 fork2
  forkIO $ createPhilosopher "P3" fork2 fork3
  forkIO $ createPhilosopher "P4" fork3 fork4
  forkIO $ createPhilosopher "P5" fork4 fork5
  readLn :: IO String
